<%
'*******************************************************************
'* Program : Power-Stats | www.power-stats.com
'* Version : 1.0
'* Authors : Ricardo Lerch, Rodrigo Alhadeff  |  authors@power-stats.com
'* Date    : March-2004
'* Details : Graphic functions 
'*			 Column bars and lines called by DrawChart
'*           Pie chart called by DrawChartPie
'*			 Column bars Comparative called by DrawChartComparative
'*			 
'*******************************************************************
%>


<%
Function DrawChart(gW, gH, gLayers, gValuesCount, gMaxVal, gMinVal, gTypes(), gValuesY(), gValuesX(), gLegends(), gFirstColor)
'Will draw an horizontal graphic for the given values
'Graphic type 1 column bars, 2 line; gTypes(), one value per layer
'gLayers qty of graphic layers to be displayed
'gValuesCount qty of values per layer
'gValuesX() array with all values for each layer must be equal to gValuesCount * gLayers
'gLegends() array containing strings to be displayed as legend


	dim chartcolors(10)
    chartcolors(0)= "#0000B7"
    chartcolors(1)= "#F3170C"
    chartcolors(2)= "#33CC33"
    chartcolors(3)= "#FFFF00"
    chartcolors(4)= "#00DFDF"
    chartcolors(5)= "#FF812D"
    chartcolors(6)= "#FF88FF"
    chartcolors(7)= "#A6FFA6"
    chartcolors(8)= "#8888FF"
    chartcolors(9)= "#FFCCCC"
    chartcolors(10)= "#CB9763"





	
	'default values
	if gW="" then gW=700
	if gH="" then gH=300

	for gl=0 to gLayers-1
		strTypes = strTypes & gTypes(gl) & ","		
		for gv=0 to gValuesCount-1
			strValsY = strValsY & gValuesY(gv + (gl*gValuesCount)) & ","
		next
	next

	parameters = parameters & "?gLayers=" & gLayers		'num of layers
	parameters = parameters & "&gValuesCount=" & gValuesCount	'qty of values per layer
	parameters = parameters & "&gMaxVal=" &	gMaxVal		'Max Value for the graph
	parameters = parameters & "&gMinVal=" &	gMinVal		'Min Value for the graph
	parameters = parameters & "&gFirstColor=" &	gFirstColor		'Min Value for the graph

	'Graphic type: 1 = Columns, 2 mean Lines
	parameters = parameters & "&gType=" & strTypes '1,2,1,2,2,2,1,1,2,1," 

	'values for the Y axix, the qty of values must be equal to gValuesCount * gLayers
	'must end with a comma ,
	parameters = parameters & "&gValuesY=" & strValsY '1,2,3,4,5,6,5.7,4.8,5.9,10,.5,1.2,2.3,1.4,3.5,4.6,7,8,9,5,1,2,3,4,5,6,7,8,9,10,"

	'Values for the X axis
	parameters = parameters & "&gValuesX=1,2,3,4,5,6,7,8,9,10,"
	
	
	'Color Values format Must be hexa 0xFF158A
	parameters = parameters & "&gColors=" '0xFFFF00,0x00FFFF,0xFF0000,0xCC00CC,0x008080,0x800000,0xFF9933,0x000080,0x00FF00,0x0066FF,"
	for n=0 to 10
		parameters = parameters & replace(chartcolors(n),"#","0x") & ","
	next
	
	'BackColor Value format Must be hexa 0xFF158A
	parameters = parameters & "&gBackColor=0xEFEFEF"
	

	
	'debug only
	'Response.Write(parameters)

	%>
	<link href="../graphicfunctions/style-graphs.css" rel=stylesheet type=text/css>
	<CENTER>
	<table border="0" bordercolor="#000000" cellspacing="0" cellpadding="0">
	  <tr>
	    <td id="tdGraphTitle" colspan="2" align="center"></td>
	  </tr>
	  <tr>
	    <td id="tdGraphAxisY" height="100%">
	    
	      <table height="100%" border="0" cellspacing="0" cellpadding="0" bordercolor="#000000">
	      <%for iValY=5 to 0 step -1%>
	        <tr>
	          <td id="tdGraphValsY" width="100%" valign="bottom" align="right"><%=round((gMaxVal*(iValY/6)),2)%></td>
	        </tr>      
	      <%next%>
	      </table>
	      
	      
	    </td>
	    <td id="tdGraphArea">
			<!--Flash Graph Here-->
			<object width="<%=gW%>" height="<%=gH%>" classid="clsid:d27cdb6e-ae6d-11cf-96b8-444553540000"     codebase="http://download.macromedia.com/pub/shockwave/cabs/flash/swflash.cab#version=7,0,0,0"  id="power-stats-chart" align="middle" VIEWASTEXT>
			<param name="allowScriptAccess" value="sameDomain" />
			<param name="movie" value="../graphicfunctions/power-stats-chart.swf<%=parameters%>" />
			<param name="quality" value="high" />
			<param name="bgcolor" value="#ffffff" />
			<embed src="../graphicfunctions/power-stats-chart.swf<%=parameters%>" quality="high" bgcolor="#ffffff" width="<%=gW%>" height="<%=gH%>" name="power-stats-chart" align="middle" allowScriptAccess="sameDomain" type="application/x-shockwave-flash" pluginspage="http://www.macromedia.com/go/getflashplayer" />
			</object>    
			<!--Flash Graph Here-->
	    </td>
	  </tr>
	  <tr>
	    <td id="tdGraphAxisXY">&nbsp;</td>
	    <td id="tdGraphAxisX">
	      <table border="0" width="100%" bordercolor="#000000" cellpadding="0" cellspacing="0">
	        <tr>
	        
				<%for iValX=0 to gValuesCount-1%>
					<td id="tdGraphValsX" width="<%=fix(100/gValuesCount)%> %" valign="middle" align="center"><%=gValuesX(iValX)%></td>
				<%next%>

	        </tr>
	      </table>
	    </td>
	  </tr>
	</table>
</CENTER>
	<BR>

	  <center>
	  <table border="0" cellspacing="0" cellpadding="4">
	  <%
	  i=gFirstColor
	  for gl=0 to gLayers-1%>
	  <tr>
	    <td id="tdGraphLegendColor" width="20px" bgcolor="<%=chartcolors(i)%>">
			&nbsp;
	    </td>
	    <td id="tdGraphLegendLabel">
			&nbsp;<%=gLegends(gl)%>
	    </td>
	  </tr>
	  <%
	  	i=i+1
		if i>=11 then i=0
	  next%>
	  </table>
	  </center>  
<%
end function



Function DrawChartPie(gW, gH, gValuesCount, gValues(), gLegendPosition, gLegends(), gFirstColor)
'gLegendPosition 1=right, 2=bottom
'gValuesCount qty of values in the pie graphic
'gValues() array with values
'gLegends() array containing strings to be displayed as legend
'gFirstColor of the color array to be drawn


	dim piecolors(10)
    piecolors(0)= "#0000B7"
    piecolors(1)= "#F3170C"
    piecolors(2)= "#33CC33"
    piecolors(3)= "#FFFF00"
    piecolors(4)= "#00DFDF"
    piecolors(5)= "#FF812D"
    piecolors(6)= "#FF88FF"
    piecolors(7)= "#A6FFA6"
    piecolors(8)= "#8888FF"
    piecolors(9)= "#FFCCCC"
    piecolors(10)= "#CB9763"


	if gW = "" then gW=200
	if gH = "" then gH=200
	
	parameters = parameters & "?gValuesCount=" & gValuesCount
	parameters = parameters & "&gFirstColor=" & gFirstColor
	parameters = parameters & "&gValues="
	for gv=0 to gValuesCount-1
		parameters = parameters & gValues(gv) & ","
	next
	
	'Color Values format Must be hexa 0xFF158A
	parameters = parameters & "&gColors=" '0xFFFF00,0x00FFFF,0xFF0000,0xCC00CC,0x008080,0x800000,0xFF9933,0x000080,0x00FF00,0x0066FF,"
	for n=0 to 10
		parameters = parameters & replace(piecolors(n),"#","0x") & ","
	next
	
	'debug only
	'Response.Write parameters

	

	%>
	<link href="../graphicfunctions/style-graphs.css" rel=stylesheet type=text/css>
	<CENTER>
	<table border="0" bordercolor="#000000" cellspacing="0" cellpadding="4">
	  <tr>
	    <td valign="top">
	    
			<object  classid="clsid:d27cdb6e-ae6d-11cf-96b8-444553540000"   codebase="http://download.macromedia.com/pub/shockwave/cabs/flash/swflash.cab#version=7,0,0,0" width="<%=gW%>" height="<%=gH%>" id="pie" align="middle" VIEWASTEXT>
			<param name="allowScriptAccess" value="sameDomain" />
			<param name="movie" value="../graphicfunctions/power-stats-chart-pie.swf<%=parameters%>" />
			<param name="quality" value="high" />
			<param name="bgcolor" value="#ffffff" />
			<embed src="../graphicfunctions/power-stats-chart-pie.swf<%=parameters%>" quality="high" bgcolor="#ffffff" width="<%=gW%>" height="<%=gH%>" name="pie" align="middle" allowScriptAccess="sameDomain" type="application/x-shockwave-flash" pluginspage="http://www.macromedia.com/go/getflashplayer" />
			</object>
	    
	    </td>
		<%
		if gLegendPosition=1 then

		else
		  Response.Write("</tr><tr>")
		end if
		%>
	    <td>
	    
	    
	  <table width="100%" border="1" bordercolor="#000000" cellspacing="0" cellpadding="4">
	  <%
	  i=gFirstColor
	  for gl=0 to gValuesCount-1%>
	  <tr>
	    <td id="tdGraphLegendColor" bgcolor="<%=piecolors(i)%>">
			&nbsp;
	    </td>
	    <td id="tdGraphLegendLabel">
			&nbsp;<%=gLegends(gl)%>
	    </td>
	  </tr>
	  <%
		i=i+1
		if i>=11 then i =0
	  next%>
	  </table>
	  
	</td>
	</tr>
	</table>
	</CENTER>
	<%

end function




Function DrawChartComparative(gW, gH, gLayers, gValuesCount, gMaxVal, gMinVal, gOrientation, gValuesY(), gValuesX(), gLegends(), gFirstColor)
'Will draw an horizontal graphic for the given values
'Graphic type 1 column bars, 2 line; gTypes(), one value per layer
'gLayers qty of graphic layers to be displayed
'gValuesCount qty of values per layer
'gValuesX() array with all values for each layer must be equal to gValuesCount * gLayers
'gLegends() array containing strings to be displayed as legend

	dim chartcolors(10)
    chartcolors(0)= "#0000B7"
    chartcolors(1)= "#F3170C"
    chartcolors(2)= "#33CC33"
    chartcolors(3)= "#FFFF00"
    chartcolors(4)= "#00DFDF"
    chartcolors(5)= "#FF812D"
    chartcolors(6)= "#FF88FF"
    chartcolors(7)= "#A6FFA6"
    chartcolors(8)= "#8888FF"
    chartcolors(9)= "#FFCCCC"
    chartcolors(10)= "#CB9763"


	
	'default values
	if gW="" then gW=700
	if gH="" then gH=300

	for gl=0 to gLayers-1
		strTypes = strTypes & "1,"	
		for gv=0 to gValuesCount-1
			strValsY = strValsY & gValuesY(gv + (gl*gValuesCount)) & ","
		next
	next

	parameters = parameters & "?gLayers=" & gLayers		'num of layers
	parameters = parameters & "&gValuesCount=" & gValuesCount	'qty of values per layer
	parameters = parameters & "&gMaxVal=" &	gMaxVal		'Max Value for the graph
	parameters = parameters & "&gMinVal=" &	gMinVal		'Min Value for the graph
	parameters = parameters & "&gFirstColor=" &	gFirstColor		'Min Value for the graph
	parameters = parameters & "&gOrientation=" & gOrientation
	
	'values for the Y axix, the qty of values must be equal to gValuesCount * gLayers
	'must end with a comma ,
	parameters = parameters & "&gValuesY=" & strValsY '1,2,3,4,5,6,5.7,4.8,5.9,10,.5,1.2,2.3,1.4,3.5,4.6,7,8,9,5,1,2,3,4,5,6,7,8,9,10,"

	'Color Values format Must be hexa 0xFF158A
	parameters = parameters & "&gColors=" '0xFFFF00,0x00FFFF,0xFF0000,0xCC00CC,0x008080,0x800000,0xFF9933,0x000080,0x00FF00,0x0066FF,"
	for n=0 to 10
		parameters = parameters & replace(chartcolors(n),"#","0x") & ","
	next
	
	'BackColor Value format Must be hexa 0xFF158A
	parameters = parameters & "&gBackColor=0xEFEFEF"
	
	'debug only
	'Response.Write(parameters)

	%>
	<link href="../graphicfunctions/style-graphs.css" rel=stylesheet type=text/css>

	<table border="0" bordercolor="#000000" cellspacing="0" cellpadding="0">
	  <tr>
	    <td id="tdGraphTitle" colspan="2" align="center"></td>
	  </tr>
	  <tr>
	    <td id="tdGraphAxisY" height="100%">
	    
	      <table height="100%" border="0" cellspacing="0" cellpadding="0" bordercolor="#000000">
	      <%for iValY=5 to 0 step -1%>
	        <tr>
	          <td id="tdGraphValsY" width="100%" valign="bottom" align="right"><%=round((gMaxVal*(iValY/6)),2)%></td>
	        </tr>      
	      <%next%>
	      </table>
	      
	      
	    </td>
	    <td id="tdGraphArea">
			<!--Flash Graph Here-->
			<object width="<%=gW%>" height="<%=gH%>" classid="clsid:d27cdb6e-ae6d-11cf-96b8-444553540000"      codebase="http://download.macromedia.com/pub/shockwave/cabs/flash/swflash.cab#version=7,0,0,0"  id="power-stats-chart" align="middle" VIEWASTEXT>
			<param name="allowScriptAccess" value="sameDomain" />
			<param name="movie" value="../graphicfunctions/power-stats-chart-comparative.swf<%=parameters%>" />
			<param name="quality" value="high" />
			<param name="bgcolor" value="#ffffff" />
			<embed src="../graphicfunctions/power-stats-chart-comparative.swf<%=parameters%>" quality="high" bgcolor="#ffffff" width="<%=gW%>" height="<%=gH%>" name="power-stats-chart" align="middle" allowScriptAccess="sameDomain" type="application/x-shockwave-flash" pluginspage="http://www.macromedia.com/go/getflashplayer" />
			</object>    
			<!--Flash Graph Here-->
	    </td>
	  </tr>
	  <tr>
	    <td id="tdGraphAxisXY">&nbsp;</td>
	    <td id="tdGraphAxisX">
	      <table border="0" width="100%" bordercolor="#000000" cellpadding="0" cellspacing="0">
	        <tr>
	        
				<%for iValX=0 to gValuesCount-1%>
					<td id="tdGraphValsX" width="<%=fix(100/gValuesCount)%>%" valign="middle" align="center"><%=gValuesX(iValX)%></td>
				<%next%>

	        </tr>
	      </table>
	    </td>
	  </tr>
	</table>

	<BR>

	  <center>
			  
		<table ID="tbGraphLabels" border="0" bordercolor="#000000" cellspacing="0" cellpadding="4">	  
		<%
		iColor=gFirstColor
		for n=0 to gValuesCount-1%>
		<tr>
		  <td id="tdGraphLegendColor" bgcolor="<%=chartcolors(iColor)%>">
		  	&nbsp;
		  </td>
		  <td id="tdGraphLegendLabel">
		  	&nbsp;<%=gLegends(n)%>
		  </td>
		</tr>
							  
		<%
			iColor = iColor+1
			if iColor >= 11 then iColor=0
				  
		next%>
		</table>
  
	  </center>  
<%
end function

%>